<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Admin extends MY_Controller {

	public function index()
	{
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			redirect('admin/add', 'refresh');
		}
		else {
			redirect('login', 'refresh');
		}
	}

	public function add()
	{
		save_current_url(base_url() . 'admin/add/');
		
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			$data['module_list'] = $this->getModuleLists();
			
			$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_admin') . ' - ' .$this->lang->line('hf_add_new_admin');
			
			$this->load->view('admin_add_new', $data);
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function submit()
	{
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			if($_POST) {
				$this->lang->load('account_general', get_language());
			
				$_POST['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_admin') . ' - ' .$this->lang->line('hf_add_new_admin');
			
				$this->load->model('user_model');
			
				$rs = $this->user_model->add_admin();
					
				if($rs) {
					redirect('admin/add/', 'refresh');
				}
				else {
					$_POST['module_list'] = $this->getModuleLists();
					
					$this->load->view('admin_add_new', $_POST);
				}
			}
			else {
				redirect('admin/add/', 'refresh');
			}
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function edit($admin_id = NULL)
	{
		save_current_url(base_url() . 'admin/edit/' . $admin_id . '/');
		
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
	
			$this->load->model('user_model');
			$data = $this->user_model->get_admin_details($admin_id);
			$data['modules'] = $this->user_model->get_admin_modules($admin_id);
			$data['module_list'] = $this->getModuleLists();
			
			$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_admin') . ' - ' .$this->lang->line('hf_edit_admin');
			
			$this->load->view('admin_update', $data);
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function update($admin_id = NULL)
	{
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			if($_POST) {
				$this->lang->load('account_general', get_language());
	
				$_POST['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_admin') . ' - ' .$this->lang->line('hf_edit_admin');
			
				$this->load->model('user_model');
				
				$rs = $this->user_model->update_admin_details($admin_id);
				
				if($rs) {
					redirect('admin/edit/' . $admin_id . '/', 'refresh');
				}
				else {
					$_POST['module_list'] = $this->getModuleLists();
					
					$this->load->view('admin_update', $_POST);
				}
			}
			else {
				redirect('admin/edit/' . $admin_id . '/', 'refresh');
			}
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function delete($admin_id = NULL)
	{
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
	
			$this->load->model('user_model');
			$this->user_model->delete_admin($admin_id);
			
			redirect('admin/listing/', 'refresh');
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function listing()
	{
		save_current_url(base_url() . 'admin/listing/');
		
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_admin') . ' - ' .$this->lang->line('hf_admin_list');
			
			$this->load->view('admin_list', $data);
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function getlist()
    {
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			/* Array of database columns which should be read and sent back to DataTables. Use a space where
			 * you want to insert a non-database field (for example a counter or static image)
			 */
			$aColumns = array(
								'user_id',
								'real_name',
								'username',
								'last_login_date',
								'status',
								'registered_date'
							);
			
			// DB table to use
			$sTable = 'users';
			//
			
			$this->db->where('user_type', ADMIN);
			
			$iDisplayStart = $this->input->get_post('iDisplayStart', true);
			$iDisplayLength = $this->input->get_post('iDisplayLength', true);
			$iSortCol_0 = $this->input->get_post('iSortCol_0', true);
			$iSortingCols = $this->input->get_post('iSortingCols', true);
			$sSearch = $this->input->get_post('sSearch', true);
			$sEcho = $this->input->get_post('sEcho', true);
		
			// Paging
			if(isset($iDisplayStart) && $iDisplayLength != '-1')
			{
				$this->db->limit($this->db->escape_str($iDisplayLength), $this->db->escape_str($iDisplayStart));
			}
			
			// Ordering
			if(isset($iSortCol_0))
			{
				for($i=0; $i<intval($iSortingCols); $i++)
				{
					$iSortCol = $this->input->get_post('iSortCol_'.$i, true);
					$bSortable = $this->input->get_post('bSortable_'.intval($iSortCol), true);
					$sSortDir = $this->input->get_post('sSortDir_'.$i, true);
		
					if($bSortable == 'true')
					{
						$this->db->order_by($aColumns[intval($this->db->escape_str($iSortCol))], $this->db->escape_str($sSortDir));
					}
				}
			}
			
			/* 
			 * Filtering
			 * NOTE this does not match the built-in DataTables filtering which does it
			 * word by word on any field. It's possible to do here, but concerned about efficiency
			 * on very large tables, and MySQL's regex functionality is very limited
			 */
			if(isset($sSearch) && !empty($sSearch))
			{
				for($i=0; $i<count($aColumns); $i++)
				{
					$bSearchable = $this->input->get_post('bSearchable_'.$i, true);
					
					// Individual column filtering
					if(isset($bSearchable) && $bSearchable == 'true')
					{
						$this->db->or_like($aColumns[$i], $this->db->escape_like_str($sSearch));
					}
				}
			}
			
			// Select Data
			$this->db->select('SQL_CALC_FOUND_ROWS '.str_replace(' , ', ' ', implode(', ', $aColumns)), false);
			$rResult = $this->db->get($sTable);
		
			// Data set length after filtering
			$this->db->select('FOUND_ROWS() AS found_rows');
			$iFilteredTotal = $this->db->get()->row()->found_rows;
		
			// Total data set length
			$iTotal = $this->db->count_all($sTable);
		
			// Output
			$output = array(
				'sEcho' => intval($sEcho),
				'iTotalRecords' => $iTotal,
				'iTotalDisplayRecords' => $iFilteredTotal,
				'aaData' => array()
			);
			
			foreach($rResult->result_array() as $aRow)
			{
				$row = array();
				
				$row[] = $aRow['real_name'];
				$row[] = $aRow['username'];
				
				switch($aRow['status']) {
					case 'P' : $row[] = '<span class="label label-pending">' . $this->lang->line('admin_pending') . '</span>'; break;
					case 'S' : $row[] = '<span class="label label-fail">' . $this->lang->line('admin_suspended') . '</span>'; break;
					case 'A' : $row[] = '<span class="label label-success">' . $this->lang->line('admin_approved') . '</span>'; break;
				}
				
				$row[] = date('Y-m-d H:i:s', $aRow['last_login_date']);
                $row[] = date('Y-m-d H:i:s', $aRow['registered_date']);
				$row[] = '<a href="' . base_url() . 'admin/edit/' . $aRow['user_id'] . '/">' . $this->lang->line('admin_edit') . '</a> | <a href="' . base_url() . 'admin/delete/' . $aRow['user_id'] . '/" onclick="return confirm(\'' . $this->lang->line('admin_confirm') . '\');">' . $this->lang->line('admin_delete') . '</a>';

                $output['aaData'][] = $row;
			}
		
			echo json_encode($output);
		}	
    }
}

/* End of file admin.php */
/* Location: ./application/controllers/admin.php */